OpenVDB: TernaryOperator Struct Reference

OpenVDB 8.1.0

Public Types | Public Member Functions | List of all members
TernaryOperator Struct Reference

A TernaryOperator represents a ternary (conditional) expression 'a ? b : c' which evaluates to 'b' if 'a' is true and 'c' if 'a' is false. Requires 'b' and 'c' to be convertibly typed expressions, or both void. The 'true' expression ('b') is optional with the conditional expression 'a' returned if it evaluates to true, otherwise returning 'c'. Note that 'a' will only be evaluated once in this case. More...

`#include <AST.h>`

Inherits Expression.

## Public Types
using | UniquePtr = std::unique_ptr< TernaryOperator >
enum | NodeType { TreeNode , StatementListNode , BlockNode , ConditionalStatementNode , CommaOperatorNode , LoopNode , KeywordNode , AssignExpressionNode , CrementNode , UnaryOperatorNode , BinaryOperatorNode , TernaryOperatorNode , CastNode , AttributeNode , FunctionCallNode , ExternalVariableNode , DeclareLocalNode , ArrayPackNode , ArrayUnpackNode , LocalNode , ValueBoolNode , ValueInt16Node , ValueInt32Node , ValueInt64Node , ValueFloatNode , ValueDoubleNode , ValueStrNode }
| An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType. More...
using | Ptr = std::shared_ptr< Node >

## Public Member Functions
| TernaryOperator (Expression *conditional, Expression *trueExpression, Expression *falseExpression)
| Construct a new TernaryOperator with a conditional expression and true (optional) and false expressions, transferring ownership of the expressions to the TernaryOperator and updating parent data on the expressions. More...
| TernaryOperator (const TernaryOperator &other)
| Deep copy constructor for a TernaryOperator, performing a deep copy on held expressions, ensuring parent information is updated. More...
| ~TernaryOperator () override=default
TernaryOperator * | copy () const override final
| The deep copy method for a Node. More...
NodeType | nodetype () const override
| Virtual method for accessing node type information. More...
const char * | nodename () const override
| Virtual method for accessing node name information. More...
const char * | subname () const override
| Virtual method for accessing node name information. More...
const Expression * | basetype () const override
| Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits. More...
size_t | children () const override final
| Virtual method for accessing child information. Returns the number of children a given AST node owns. More...
const Expression * | child (const size_t i) const override final
| Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned. More...
bool | replacechild (const size_t i, Node *node) override final
| Virtual method that attempted to replace a child at a given index with a provided node type. More...
bool | hasTrue () const
| Query whether or not this has an optional if-true branch. More...
const Expression * | condition () const
| Access a const pointer to the TernaryOperator conditional as an abstract expression. More...
const Expression * | trueBranch () const
| Access a const pointer to the TernaryOperator true expression as an abstract expression. More...
const Expression * | falseBranch () const
| Access a const pointer to the TernaryOperator false expression as an abstract expression. More...
Name/Type
template<typename NodeT >
bool | isType () const
| Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype() More...
Child Queries
int64_t | childidx () const
| Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree) More...
Replacement
bool | replace (Node *node)
| In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements. More...
Parent
const Node * | parent () const
| Access a const pointer to this nodes parent. More...
void | setParent (Node *parent)
| Set this node's parent. This is used during construction of an AST and should not be used. More...

## Detailed Description

A TernaryOperator represents a ternary (conditional) expression 'a ? b : c' which evaluates to 'b' if 'a' is true and 'c' if 'a' is false. Requires 'b' and 'c' to be convertibly typed expressions, or both void. The 'true' expression ('b') is optional with the conditional expression 'a' returned if it evaluates to true, otherwise returning 'c'. Note that 'a' will only be evaluated once in this case.

## Member Typedef Documentation

## ◆ Ptr

using Ptr = std::shared_ptr<Node>
| inherited

## ◆ UniquePtr

using UniquePtr = std::unique_ptr<TernaryOperator>

## Member Enumeration Documentation

## ◆ NodeType

enum NodeType
| inherited

An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType.

Note
  This is sometimes referred to as "manual RTTI". We use this technique combine with single dispatch due to opting for CRTP on the main visitor and no templated virtual method support in C++. i.e. no way to double dispatch: visit<template T>(Visitor<T>*)
  Abstract (pure-virtual) nodes are not listed here. Node::isType should be used to determine if a node is of a given abstract type.

Enumerator
TreeNode |
StatementListNode |
BlockNode |
ConditionalStatementNode |
CommaOperatorNode |
LoopNode |
KeywordNode |
AssignExpressionNode |
CrementNode |
UnaryOperatorNode |
BinaryOperatorNode |
TernaryOperatorNode |
CastNode |
AttributeNode |
FunctionCallNode |
ExternalVariableNode |
DeclareLocalNode |
ArrayPackNode |
ArrayUnpackNode |
LocalNode |
ValueBoolNode |
ValueInt16Node |
ValueInt32Node |
ValueInt64Node |
ValueFloatNode |
ValueDoubleNode |
ValueStrNode |

## Constructor & Destructor Documentation

## ◆ TernaryOperator() [1/2]

TernaryOperator | ( | Expression * | conditional,
|  | Expression * | trueExpression,
|  | Expression * | falseExpression
| ) |  |
| inline

Construct a new TernaryOperator with a conditional expression and true (optional) and false expressions, transferring ownership of the expressions to the TernaryOperator and updating parent data on the expressions.

Parameters

  conditional | The conditional expression determining the expression selection
  trueExpression | The (optional) expression evaluated if the condition is true
  falseExpression | The expression evaluated if the condition is false

## ◆ TernaryOperator() [2/2]

TernaryOperator | ( | const TernaryOperator & | other | ) |
| inline

Deep copy constructor for a TernaryOperator, performing a deep copy on held expressions, ensuring parent information is updated.

Parameters

  other | A const reference to another TernaryOperator to deep copy

## ◆ ~TernaryOperator()

~TernaryOperator | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ basetype()

const Expression* basetype | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.

Reimplemented from Expression.

## ◆ child()

const Expression* child | ( | const size_t | i | ) | const
| inlinefinaloverridevirtual

Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.

Implements Node.

## ◆ childidx()

int64_t childidx | ( |  | ) | const
| inlineinherited

Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree)

Returns
  The child index of this node

## ◆ children()

size_t children | ( |  | ) | const
| inlinefinaloverridevirtual

Virtual method for accessing child information. Returns the number of children a given AST node owns.

Implements Node.

## ◆ condition()

const Expression* condition | ( |  | ) | const
| inline

Access a const pointer to the TernaryOperator conditional as an abstract expression.

Returns
  A const pointer to the conditional expression

## ◆ copy()

TernaryOperator* copy | ( |  | ) | const
| inlinefinaloverridevirtual

The deep copy method for a Node.

Implements Expression.

## ◆ falseBranch()

const Expression* falseBranch | ( |  | ) | const
| inline

Access a const pointer to the TernaryOperator false expression as an abstract expression.

Returns
  A const pointer to the false expression

## ◆ hasTrue()

bool hasTrue | ( |  | ) | const
| inline

Query whether or not this has an optional if-true branch.

## ◆ isType()

bool isType | ( |  | ) | const
| inlineinherited

Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype()

Template Parameters

  NodeT | The node type to query against.

Returns
  True if this node is of the given type, false otherwise.

## ◆ nodename()

const char* nodename | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing node name information.

Implements Node.

## ◆ nodetype()

NodeType nodetype | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing node type information.

Implements Node.

## ◆ parent()

const Node* parent | ( |  | ) | const
| inlineinherited

Access a const pointer to this nodes parent.

Note
  Can be a nullptr if this is the top most node in an AST (usually a Tree)

Returns
  A const pointer to this node's parent node

## ◆ replace()

bool replace | ( | Node * | node | ) |
| inlineinherited

In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.

Note
  A replacement will fail if this node is the top most node within an AST hierarchy or if the provided node type is not a compatible type for the required abstract storage. For example, if this node is an Attribute being held on a BinaryOperator, only concrete nodes derived from an Expression can be used as a replacement.
  This method will dynamic_cast the provided node to check to see if it's a compatible type.

Parameters

  node | The node to insert on a successful replacement.

Returns
  True if the replacement was successful, resulting in destruction of this class and ownership transferal of the provided node. False otherwise, where this and the provided node are unchanged.

## ◆ replacechild()

bool replacechild | ( | const size_t | i,
|  | Node * | node
| ) |  |
| inlinefinaloverridevirtual

Virtual method that attempted to replace a child at a given index with a provided node type.

Reimplemented from Node.

## ◆ setParent()

void setParent | ( | Node * | parent | ) |
| inlineinherited

Set this node's parent. This is used during construction of an AST and should not be used.

Parameters

  parent | The parent to set

## ◆ subname()

const char* subname | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing node name information.

Implements Node.

## ◆ trueBranch()

const Expression* trueBranch | ( |  | ) | const
| inline

Access a const pointer to the TernaryOperator true expression as an abstract expression.

Returns
  A const pointer to the true expression

The documentation for this struct was generated from the following file:

- AST.h